//*******************************************************************************************
// Insieme dei comandi riconosciuti dal sistema Domotino
//*******************************************************************************************

void ComputeCommand ()
{	unsigned char tamp1 = 0;
	unsigned char tamp2 = 0;
	unsigned char tamp3 = 0;
	unsigned char lowByte, highByte,datum;
	unsigned char temperatureLCD [2]; 	//stringa che contiene il valore della temperatura
	unsigned char batteryLevelLCD [3]; 	//stringa che contiene il valore del livello batteria
	unsigned char distanceLCD [3]; 		//stringa che contiene il valore della distanza
	int i;

//***********************************************************
//comando per cambio orario
//***********************************************************		
	
	if (data[0] == 'T')			
		{	tamp1 = data[1]-48;
			tamp2 = data[2]-48;
			tamp3 = tamp1 << 4;
			tamp3 = tamp3 | tamp2;
			
			WriteHours (tamp3);
			
			tamp1 = data[3]-48;
			tamp2 = data[4]-48;
			tamp3 = tamp1 << 4;
			tamp3 = tamp3 | tamp2;
			
			WriteMinutes (tamp3);
			
			tamp1 = data[5]-48;
			tamp2 = data[6]-48;
			tamp3 = tamp1 << 4;
			tamp3 = tamp3 | tamp2;
			
			WriteSeconds (tamp3);
			
			WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso	
			putrsUSART("Time has been updated");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso
			
		}
	else

//***********************************************************
//comando per lettura orario con secondi
//***********************************************************

	if (data[0] == 't')			
		{	WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso	
			putrsUSART("Time: ");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso
			putsUSART(ReadTimeSeconds());					
		}
	else

//***********************************************************
//comando per cambio data
//***********************************************************
	
	if (data[0] == 'D')			
		{	tamp1 = data[1]-48;
			tamp2 = data[2]-48;
			tamp3 = tamp1 << 4;
			tamp3 = tamp3 | tamp2;
			
			WriteDays (tamp3);
			
			tamp1 = data[3]-48;
			tamp2 = data[4]-48;
			tamp3 = tamp1 << 4;
			tamp3 = tamp3 | tamp2;
			
			WriteMonths (tamp3);
			
			tamp1 = data[5]-48;
			tamp2 = data[6]-48;
			tamp3 = tamp1 << 4;
			tamp3 = tamp3 | tamp2;
			
			WriteYears (tamp3);
			
			WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso	
			putrsUSART("Date has been updated");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso
			
		}
	else

//***********************************************************
//comando per lettura data
//***********************************************************
		
	if (data[0] == 'd')			
		{	WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso	
			putrsUSART("Date: ");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso		
			putsUSART(ReadDate());	
			while (BusyUSART());		// attendo che il testo venga trasmesso					
		}
		
	else
	
//***********************************************************
//comando per andare avanti
//***********************************************************
		
	if (data[0] == 'F')		
		{	 			
			Forward (speedTable[data[1]-48]); //sottranendo 48 converto ascii in numero	
			WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso	
			putrsUSART("Direction: Forward");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso	
			WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso	
			putrsUSART("Speed: ");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso
			WriteUSART(data[1]);	
			while (BusyUSART());		// attendo che il testo venga trasmesso				
		}
	
	else
	
//***********************************************************
//comando per fermare i motori
//***********************************************************		
	if (data[0] == 'S')		
		{
			Halt ();
			WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso	
			putrsUSART("Domotino has been stopped");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso	
			
		}
		
	else
	
//***********************************************************
//comando per andare a destra
//***********************************************************		
	if (data[0] == 'R')		
		{
			turnRight (speedTable[data[1]-48]);//sottranendo 48 converto ascii in numero
			WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso	
			putrsUSART("Direction: Right");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso	
			WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso	
			putrsUSART("Speed: ");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso
			WriteUSART(data[1]);	
			while (BusyUSART());		// attendo che il testo venga trasmesso			
		}
		
	else
	
//***********************************************************
//comando per andare a sinistra
//***********************************************************		
	if (data[0] == 'L')		
		{
			turnLeft (speedTable[data[1]-48]);//sottranendo 48 converto ascii in numero
			WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso	
			putrsUSART("Direction: Left");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso	
			WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso	
			putrsUSART("Speed: ");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso
			WriteUSART(data[1]);	
			while (BusyUSART());		// attendo che il testo venga trasmesso			
		}
		
	else

//***********************************************************
//comado per andare indietro
//***********************************************************		
	if (data[0] == 'B')		
		{
			Backwards (speedTable[data[1]-48]);//sottranendo 48 converto ascii in numero
			WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso	
			putrsUSART("Direction: Backward");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso	
			WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso	
			putrsUSART("Speed: ");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso
			WriteUSART(data[1]);	
			while (BusyUSART());		// attendo che il testo venga trasmesso		
		}
		
	else	

//***********************************************************
//comado per richiedere la modalit
//***********************************************************
	if (data[0] == '?')		
		{	WriteUSART(13);	// invio carattere ritorno a capo
			putrsUSART("Modality: ");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso	
			WriteUSART(modality + 48);  	// converto in asci il numero	 
		}
	
	else

//***********************************************************
//comado per posizionare il sensore ad ultrasuoni
//***********************************************************	
	if (data[0] == 's')		
		{	
			WriteUSART(13);	// invio carattere ritorno a capo
			putrsUSART("Ultrasonic Sensor : ");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso
			
			ServoDirection = data[1] - 48; 
			
			if (ServoDirection == 1)
				putrsUSART("Left");  	// Trasmetto il testo
			
			if (ServoDirection == 2)
				putrsUSART("Frontal");  	// Trasmetto il testo
				
			if (ServoDirection == 3)
				putrsUSART("Right");  	// Trasmetto il testo			
			
			while (BusyUSART());		// attendo che il testo venga trasmesso			
				 
		}
	
	else

//***********************************************************
//comado per leggere la distanza
//***********************************************************	
	if (data[0] == 'f')		
		{
			WriteUSART(13);	// invio carattere ritorno a capo
			putrsUSART("Distance : ");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso	
			
			itoa (RemoteDistance,distanceLCD);// converto la distanza in stringa
				
			if (!isdigit(distanceLCD[1]))	
			{
				distanceLCD[2]=distanceLCD[0];
				distanceLCD[1]=' ';
				distanceLCD[0]=' ';	
			}
		
			if (!isdigit(distanceLCD[2]))
			{	
				distanceLCD[2]=distanceLCD[1];
				distanceLCD[1]= distanceLCD[0];
				distanceLCD[0]=' ';						
			}
			
			WriteUSART(distanceLCD[0]);  	// cifra decine
			while (BusyUSART());	// attendo che il dato venga trasmesso	
			WriteUSART(distanceLCD[1]);  	// unita'
			while (BusyUSART());	// attendo che il dato venga trasmesso
			WriteUSART(distanceLCD[2]);  	// unita'
			while (BusyUSART());	// attendo che il dato venga trasmesso			
			
		}
  	else

//***********************************************************
//comado per controllare la PORTE
//***********************************************************
  	if (data[0] == 'P')		
		{
			PORTEbits.RE2 = data[1]-48; //sottranendo 48 converto ascii in numero
			PORTEbits.RE1 = data[2]-48; //sottranendo 48 converto ascii in numero
			PORTEbits.RE0 = data[3]-48; //sottranendo 48 converto ascii in numero
			
			WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso	
			putrsUSART("PORTE has been updated");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso	
					
		}
  	else

//***********************************************************
//comado per cambiare modalit
//***********************************************************  	
  	if (data[0] == 'M')		
		{
			modality = data[1] - 48 ; //sottranendo 48 converto ascii in numero
			WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso	
			putrsUSART("Modality has been updated");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso	
		}
  	else

//***********************************************************
//comado per la lettura della temperatura
//***********************************************************   	
  	if (data[0] == 'w')		
		{
			itoa (temperature,temperatureLCD);// converto la temperatura in stringa
	
			if (!isdigit(temperatureLCD[1]))	
			{	temperatureLCD[1]= temperatureLCD[0];
				temperatureLCD[0]=' ';
			}	
			
			WriteUSART(13);	// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso
			putrsUSART("Temperature : ");  	// inserisco il testo 
			while (BusyUSART());		// attendo che il dato venga trasmesso
			
			WriteUSART(temperatureLCD[0]);  	// cifra decine
			while (BusyUSART());	// attendo che il dato venga trasmesso	
			WriteUSART(temperatureLCD[1]);  	// unita'
			while (BusyUSART());	// attendo che il dato venga trasmesso
			
			putrsUSART(" 'C");  	// Trasmetto C
			while (BusyUSART());	// attendo che il dato venga trasmesso		
			
	}
  	else
 
//***********************************************************
//comado per la lettura del livello batteria
//*********************************************************** 	
  	  	if (data[0] == 'l')		
		{
			itoa (batteryLevel,batteryLevelLCD);// converto la temperatura in stringa
	
			
			if (!isdigit(batteryLevelLCD[1]))	
			{
				batteryLevelLCD[2]=batteryLevelLCD[0];
				batteryLevelLCD[1]=' ';
				batteryLevelLCD[0]=' ';	
			}
		
			if (!isdigit(batteryLevelLCD[2]))
			{	
				batteryLevelLCD[2]=batteryLevelLCD[1];
				batteryLevelLCD[1]= batteryLevelLCD[0];
				batteryLevelLCD[0]=' ';						
			}	
			
			WriteUSART(13);	// invio carattere ritorno a capo
			putrsUSART("Battery Level : ");  	// inserisco il testo 
			while (BusyUSART());		// attendo che il dato venga trasmesso
			
			WriteUSART(batteryLevelLCD[0]);  	// cifra decine
			while (BusyUSART());	// attendo che il dato venga trasmesso	
			WriteUSART(batteryLevelLCD[1]);  	// unita'
			while (BusyUSART());	// attendo che il dato venga trasmesso
			WriteUSART(batteryLevelLCD[2]);  	// unita'
			while (BusyUSART());	// attendo che il dato venga trasmesso
			
			putrsUSART("%");  	// Trasmetto %
			while (BusyUSART());	// attendo che il dato venga trasmesso		
			
		}
  	else

//***********************************************************
//comado per inizializzare il sistema
//***********************************************************   	
  	if (data[0] == 'X')		
		{	WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso		
			initialize () ;
			WriteUSART(13);	// invio carattere ritorno a capo
			while (BusyUSART());	// attendo che il dato venga trasmesso
			
			putrsUSART("System has been initialized");  	// inserisco il testo 
			while (BusyUSART());	// attendo che il dato venga trasmesso
  		} 
  		
  	else		

//***********************************************************
//comando per cambio orario sveglia
//***********************************************************   		
  	if (data[0] == 'W')			
		{	tamp1 = data[1]-48;
			tamp2 = data[2]-48;
			tamp3 = tamp1 << 4;
			tamp3 = tamp3 | tamp2;
			
			WriteEEprom (0xA0,0x01,0x00,tamp3); // scrivo l'ora nella EEPROM
			for (i=0; i<1000; i++);	//pausa
			
			if ((data[7]-48) ==1)
					WriteHoursAlarm (tamp3,Enable_ON);
				else
					WriteHoursAlarm (tamp3,Enable_OFF);
			
			tamp1 = data[3]-48;
			tamp2 = data[4]-48;
			tamp3 = tamp1 << 4;
			tamp3 = tamp3 | tamp2;
			
			WriteEEprom (0xA0,0x01,0x01,tamp3); // scrivo i minuti nella EEPROM
			for (i=0; i<1000; i++);				// pausa
			
			if ((data[7]-48) ==1)
					WriteMinutesAlarm (tamp3,Enable_ON);
				else
					WriteMinutesAlarm (tamp3,Enable_OFF);

			tamp1 = data[7]-48;
			WriteEEprom (0xA0,0x01,0x02,tamp1); // flag per segnalare allarme on
			
			WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso	
			putrsUSART("Alarm Time has been updated");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso
						
		}
		
		else				

//***********************************************************
//Scrittura EEPROM
//***********************************************************  		
		if (data[0] == 'E')			
		{	
			//imposto il byte d'indirizzo alto
			
			if (data[1]-48 > 9)
				tamp1 = data[1]-55;	// ho una lettera
			else
				tamp1 = data[1]-48;
				
			if (data[2]-48 > 9)
				tamp2 = data[2]-55;// ho una lettera
			else
				tamp2 = data[2]-48;
				
			highByte = tamp1 << 4;
			highByte = highByte | tamp2;
			
			//imposto il byte d'indirizzo basso
			if (data[3]-48 > 9)
				tamp1 = data[3]-55;	// ho una lettera
			else
				tamp1 = data[3]-48;
				
			if (data[4]-48 > 9)
				tamp2 = data[4]-55; // ho una lettera
			else
				tamp2 = data[4]-48;
				
			lowByte = tamp1 << 4;
			lowByte = lowByte | tamp2;
			
			// imposto il dato da scrivere nella EEPROM
			
			if (data[5]-48 > 9)
				tamp1 = data[5]-55;	// ho una lettera
			else
				tamp1 = data[5]-48;
				
			if (data[6]-48 > 9)
				tamp2 = data[6]-55; // ho una lettera
			else
				tamp2 = data[6]-48;
			
			datum = tamp1 << 4;
			datum = datum | tamp2;
			
			WriteEEprom (0xA0,highByte,lowByte,datum);
			
			WriteUSART(13);				// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso	
			putrsUSART("EEPROM has been written");  	// Trasmetto il testo
			while (BusyUSART());		// attendo che il testo venga trasmesso
		}
		
		else

//***********************************************************
//Lettura EEPROM
//***********************************************************		
		if (data[0] == 'C')			
		{	
			//imposto il byte d'indirizzo alto
			
			if (data[1]-48 > 9)
				tamp1 = data[1]-55;	// ho una lettera
			else
				tamp1 = data[1]-48;
				
			if (data[2]-48 > 9)
				tamp2 = data[2]-55;// ho una lettera
			else
				tamp2 = data[2]-48;
				
			highByte = tamp1 << 4;
			highByte = highByte | tamp2;
			
			//imposto il byte d'indirizzo basso
			if (data[3]-48 > 9)
				tamp1 = data[3]-55;	// ho una lettera
			else
				tamp1 = data[3]-48;
				
			if (data[4]-48 > 9)
				tamp2 = data[4]-55; // ho una lettera
			else
				tamp2 = data[4]-48;
				
			lowByte = tamp1 << 4;
			lowByte = lowByte | tamp2;
			
			datum = ReadEEprom (0xA0,highByte,lowByte);	//leggo il dato dalla EEPROM
			
			WriteUSART(13);	// invio carattere ritorno a capo
			
			putrsUSART("Datum: 0x");  	// Trasmetto il carattere D
			while (BusyUSART());		// attendo che il dato venga trasmesso	
									
			tamp1 = (datum & 0b11110000);
			tamp1 = tamp1 >> 4;
			
						if (tamp1>9)	
							tamp2 = tamp1 + 55;	//ho una lettera
						else
							tamp2 = tamp1 + 48;
							
			WriteUSART(tamp2);  	// trasmetto i 4 bit pi significativi del dato letto				
			while (BusyUSART());	// attendo che il dato venga trasmesso
			
			tamp1 = (datum & 0b00001111);
						if (tamp1>9)
							tamp2 = tamp1+ 55;	//ho una lettera
						else
							tamp2 = tamp1 + 48;
			WriteUSART(tamp2);  	// trasmetto i 4 bit meno significativi del dato letto
			while (BusyUSART());	// attendo che il dato venga trasmesso		

		}
		
		else
		{	WriteUSART(13);	// invio carattere ritorno a capo
			while (BusyUSART());		// attendo che il dato venga trasmesso
			putrsUSART("Unknown Command");  	// Trasmetto il testo
			while (BusyUSART());				// attendo che il dato venga trasmesso
			WriteUSART(13);						// invio carattere ritorno a capo			
		}
		
		WriteUSART(13);				// invio carattere ritorno a capo
		while (BusyUSART());		// attendo che il dato venga trasmesso		 	
}
