
//*******************************************************************************************
//funzione di ritardo
//*******************************************************************************************
void Delay (int time)
{	int i;
	int j;

	for (j=0; j<time;j++)
		for (i=0; i<12000; i++);
}


//*******************************************************************************************
//funzione per generare un beep con il cicalino
//*******************************************************************************************
void beep ()
{	int i;
	
	PIEZO = 1;
	Delay (2);
	PIEZO = 0;
}


//*******************************************************************************************
//funzione per copiare la seconda stringa nella prima
//*******************************************************************************************
void copyStr (char * dest, char* orig)
{
	while (*orig != '\0')
	{
		*dest = *orig;
		dest++;
		orig++;	
	}
	
	*dest= '\0';	
}


//*******************************************************************************************
// calcola la differenza in minuti di due orari
//*******************************************************************************************

unsigned char deltaTime (unsigned char* Time1, unsigned char* Time2)
{
	int min1 = 0;
	int min2 = 0;
	static int delta = 0;
	
	min1 = (Time1[4] - 48)  + ((Time1[3]-48) * 10);
	min1 = min1 + ((Time1[1] - 48) + ((Time1[0]-48) * 10))*60;
	
	min2 = (Time2[4] - 48) + ((Time2[3]-48) * 10);
	min2 = min2 + ((Time2[1] - 48) + ((Time2[0]-48) * 10))*60;

	delta = min2-min1;
	
	return (delta);	
}


//*******************************************************************************************
//funzione per inizializzare la EEPROM al primo avvio di Domotino
//*******************************************************************************************
void firstRun (void)
{	
	WriteEEprom (0xA0,0x00,0x50,1);		// Beep Lamp Service
	Delay (2); //ritardo per la scrittura
	
	WriteEEprom (0xA0,0x00,0x51,1);		// Beep pulsante cambio modalit 
	Delay (2); //ritardo per la scrittura
	
	WriteEEprom (0xA0,0x00,0x52,1);		// Beep ad ogni urto
	Delay (2); //ritardo per la scrittura
	
	WriteEEprom (0xA0,0x00,0x53,1);		// Attiva Explorer dopo la sveglia
	Delay (2); //ritardo per la scrittura
	
	WriteEEprom (0xA0,0x10,0x00,8);		// Ora della sveglia 8
	Delay (2); //ritardo per la scrittura
	
	WriteEEprom (0xA0,0x10,0x01,1);		// Minuti 00 della sveglia
	Delay (2); //ritardo per la scrittura
	
	WriteEEprom (0xA0,0x10,0x02,0);		// Sveglia disattivata
	Delay (2); //ritardo per la scrittura
	
 	WriteEEprom (0xA0,0x00,0x70,200);	// MAX_DISTANCE la distanza massima sar moltiplicata per 2
	Delay (2); //ritardo per la scrittura
	
	WriteEEprom (0xA0,0x00,0x71,175);	//NIGHT_LEVEL il livello verr moltiplicato per due
	Delay (2); //ritardo per la scrittura
	
	WriteEEprom (0xA0,0x00,0x72,20);	//DELTA_DISTANCE 
	Delay (2); //ritardo per la scrittura
	
	WriteEEprom (0xA0,0x00,0x73,50);	//LIGHT_FILTER
	Delay (2); //ritardo per la scrittura
	
	WriteEEprom (0xA0,0x00,0x74,8);		//NUM_BLOCK
	Delay (2); //ritardo per la scrittura
	
	WriteEEprom (0xA0,0x00,0x75,5);		//DELTA_BLOCK
	Delay (2); //ritardo per la scrittura
	
	WriteEEprom (0xA0,0x00,0x76,30);		// Tempo pulizia
	Delay (2); //ritardo per la scrittura
	
	WriteEEprom (0xA0,0x00,0x77,3);		// Tempo Luci ON in Lamp Service Bis
	Delay (2); //ritardo per la scrittura	
	
}


//*******************************************************************************************
//funzione per inviare le informazioni di sistema via RS232
//*******************************************************************************************

void InitializationText ()
{
	unsigned char data,tamp;
	
 	WriteUSART(13);	// invio carattere ritorno a capo
 	putrsUSART("*********************************************************");// Trasmetto il testo
	while (BusyUSART());	// attendo che il dato venga trasmesso	
	WriteUSART(13);			// invio carattere ritorno a capo
 	
 	WriteUSART(13);			// invio carattere ritorno a capo
	
	putrsUSART("Firmware Robot Domotino");  	// Trasmetto il testo
	while (BusyUSART());						// attendo che il dato venga trasmesso	
	WriteUSART(13);				// invio carattere ritorno a capo
	
	putrsUSART("Version 1.1");  // Trasmetto il testo
	while (BusyUSART());		// attendo che il dato venga trasmesso	
	WriteUSART(13);				// invio carattere ritorno a capo
	
	putrsUSART("Copyright 2006 by Mauro Laurenti");  	// Trasmetto il testo
	while (BusyUSART());		// attendo che il dato venga trasmesso
	WriteUSART(13);				// invio carattere ritorno a capo
	
	WriteUSART(13);				// invio carattere ritorno a capo
	
/*	putrsUSART("Date: ");  	// Trasmetto il testo
	putsUSART(ReadDate ()); // Trasmetto il testo
	while (BusyUSART());	// attendo che il dato venga trasmesso
	WriteUSART(13);			// invio carattere ritorno a capo
	
	putrsUSART("Time: ");  	// Trasmetto il testo
	putsUSART(ReadTime());  // Trasmetto il testo
	while (BusyUSART());	// attendo che il dato venga trasmesso
	WriteUSART(13);			// invio carattere ritorno a capo
*/	
	WriteUSART(13);			// invio carattere ritorno a capo
	
	putrsUSART("*********************************************************"); // Trasmetto il testo
	while (BusyUSART());		// attendo che il dato venga trasmesso	
	WriteUSART(13);				// invio carattere ritorno a capo


//***********************************************************
//controllo di prima esecuzione del firmware (indirizzo 0x0000)
//***********************************************************
	
	data = ReadEEprom (0xA0,0x00,0x00); // leggo l'indirizzo 0000H
	
	if (data != 0x55)
	{
		WriteUSART(13);				// invio carattere ritorno a capo (prima esecuzione)	
		putrsUSART("Domotino first Execution.");  	// Trasmetto il testo
		WriteEEprom (0xA0,0x00,0x00,0x55);	//scrivo 0x55 all'indirizzo 0
		Delay (2); //ritardo per la scrittura
		WriteUSART(13);	// invio carattere ritorno a capo		
		while (BusyUSART());		// attendo che il dato venga trasmesso
		
		firstRun (); //imposto le costanti al valore di default
	}
	
	
//***********************************************************
//se le costanti interne non sono mai state impostaste si suggerisce di farlo (indirizzo 0x0001) 
//***********************************************************
	
	data = ReadEEprom (0xA0,0x00,0x01); // leggo l'indirizzo 0001H (setting effettuato)
	
	if (data != 0xAA)
	{
		WriteUSART(13);	// invio carattere ritorno a capo	
		putrsUSART("WARNING : Constants setting is recomended");  	// Trasmetto il testo
		WriteUSART(13);	// invio carattere ritorno a capo
		while (BusyUSART());		// attendo che il dato venga trasmesso
	}


//***********************************************************
// Controllo presenza e funzionalit EEPROM indirizzo 0x0002
//***********************************************************	
	WriteUSART(13);	// invio carattere ritorno a capo	
	putrsUSART("EEPROM Test: ");  	// Trasmetto il testo
	while (BusyUSART());		// attendo che il dato venga trasmesso
	
	data = ReadEEprom (0xA0,0x00,0x02); // leggo l'indirizzo 0002H (TEST EEPROM)
	
	data++; // incremento ild ato letto
	WriteEEprom (0xA0,0x00,0x02,data);	//scrivo il nuovo dato all'indirizzo 0x02
	tamp = data;
	
	Delay (2); //ritardo per la scrittura
	
	data = ReadEEprom (0xA0,0x00,0x02); // rileggo il dato
	
	if (data==tamp) // controllo se il dato riletto  incrementato
		putrsUSART("PASSED");  	// Trasmetto il testo
	else	
		putrsUSART("FAILED");  	// Trasmetto il testo
			
	WriteUSART(13);				// invio carattere ritorno a capo
	while (BusyUSART());		// attendo che il dato venga trasmesso


//***********************************************************
// EEPROM Size indirizzo 0xFFFF
//***********************************************************	
	WriteUSART(13);	// invio carattere ritorno a capo	
	putrsUSART("EEPROM Size Test: ");  	// Trasmetto il testo
	while (BusyUSART());		// attendo che il dato venga trasmesso
	
	data = ReadEEprom (0xA0,0xFF,0xFF); // leggo l'indirizzo 0xFFFF(TEST EEPROM)
	data++; // incremento ild ato letto
	WriteEEprom (0xA0,0xFF,0xFF,data);	//scrivo 0x55 all'indirizzo 0xFFFF
	tamp = data;
	
	Delay (2); //ritardo per la scrittura
	
	data = ReadEEprom (0xA0,0xFF,0xFF); // rileggo il dato
	
	if (data==tamp) // controllo se il dato riletto  incrementato
		putrsUSART("PASSED");  	// Trasmetto il testo	
	else	
		putrsUSART("FAILED");  	// Trasmetto il testo
	
	WriteUSART(13);				// invio carattere ritorno a capo
	while (BusyUSART());		// attendo che il dato venga trasmesso


//***********************************************************
// Controllo presenza e funzionalit Clock Calendar
//***********************************************************
	WriteUSART(13);	// invio carattere ritorno a capo	
	putrsUSART("Clock/Calendar Test: ");  	// Trasmetto il testo
	while (BusyUSART());		// attendo che il dato venga trasmesso
	
	data = ReadSeconds ();
	
	while ((data-ReadSeconds ())> 2); //Quando la differenza e' maggiore di 2 il test passa
	putrsUSART("PASSED");  	// Trasmetto il testo
	
	WriteUSART(13);				// invio carattere ritorno a capo
	while (BusyUSART());		// attendo che il dato venga trasmesso


//***********************************************************
// Fine Test
//***********************************************************	

}

