
//*******************************************************************************************
//inizializzo le varie periferiche interne al PIC
//*******************************************************************************************

void initialize ()
{	unsigned char data;	//variabile tampone per lettura EEPROM
	unsigned char flag;	//usata come tampone per il flag allarme attivo
	
	OpenI2C(MASTER, SLEW_ON);	// Initializza il modulo I2C a 400KHz  
	SSPADD = 14; 				//400kHz Baud clock @20MHz
	
	OpenLCD ();					// inizializzo LCD
	WriteSponsor ();
	
	EnablePullups(); 			// abilito i resistori di pull-up

	// Configura l'USART
	// 8 bit
	// 19200 bit/s
	// 1 bit stop
	// 0 bit parita'
	
	OpenUSART( USART_TX_INT_OFF &
	USART_RX_INT_ON &
	USART_ASYNCH_MODE &
	USART_EIGHT_BIT &
	USART_CONT_RX &
	USART_BRGH_HIGH,
	64 ); 
	
	if (!initDone)
		{
			InitializationText () ;	// invio caratteristiche del sistema via RS232
			initDone = 1;
		}
		
	
	//prelevo i dati dalla EEPROM
	
	MAX_DISTANCE = ReadEEprom (0xA0,0x00,0x70); // leggo l'indirizzo 0x0070
	MAX_DISTANCE = MAX_DISTANCE << 2; // moltiplico per 2 il valore della EEPROM
	NIGHT_LEVEL = ReadEEprom (0xA0,0x00,0x71); // leggo l'indirizzo 0x0071
	NIGHT_LEVEL = NIGHT_LEVEL << 2; // moltiplico per 2 il valore della EEPROM
	DELTA_DISTANCE = ReadEEprom (0xA0,0x00,0x72); // leggo l'indirizzo 0x0072
	LIGHT_FILTER = ReadEEprom (0xA0,0x00,0x73); // leggo l'indirizzo 0x0073
	NUM_BLOCK = ReadEEprom (0xA0,0x00,0x74);   // leggo l'indirizzo 0x0074
	DELTA_BLOCK = ReadEEprom (0xA0,0x00,0x75); // leggo l'indirizzo 0x0075
	
	// inizializzo orologio
	
	
 	flag = ReadEEprom (0xA0,0x01,0x02); // leggo l'indirizzo 0102H (flag sveglia)		

 	data = ReadEEprom (0xA0,0x01,0x00); // leggo l'indirizzo 0100H (ORA)
 	
 	if (flag ==1)
		WriteHoursAlarm (data,Enable_ON);
	else
		WriteHoursAlarm (data,Enable_OFF);
					 	
 	
 	data = ReadEEprom (0xA0,0x01,0x01); // leggo l'indirizzo 0101H (MINUTI)	
 	
 	if (flag ==1)
		WriteMinutesAlarm (data,Enable_ON);
	else
		WriteMinutesAlarm (data,Enable_OFF); 	
 	
 	// fine inizializzazione orologio
 
 
 	OpenTimer2( TIMER_INT_OFF &	T2_PS_1_1 & T2_POST_1_1);	// apro il TMR2 per il PWM
	
	OpenTimer0 (TIMER_INT_ON & T0_SOURCE_INT & T0_16BIT );	//contatore uso generale
	
	speedTable[0] = 0;		//tabella della velocit
	speedTable[1] = 700;	
	speedTable[2] = 750;
	speedTable[3] = 800;
	speedTable[4] = 850;
	speedTable[5] = 1023;
	
	beep ();
	
 	INTCONbits.RBIE = 1; 	// abilito le interruzioni su PORTB
 	
 	INTCONbits.PEIE = 1 ;  	// abilito interrupt per periferiche
 	INTCONbits.GIE = 1; 	// Abilito l'interrupt globale
 	
 	ClearLCD ();
 	
 	modality = MODA;			// la modalit di avvio  modA 
 	
 	WriteUSART(13);				// invio carattere ritorno a capo
	while (BusyUSART());		// attendo che il dato venga trasmesso
	
	putrsUSART("System Ready...");  	// Trasmetto il testo
	while (BusyUSART());		// attendo che il dato venga trasmesso
	WriteUSART(13);				// invio carattere ritorno a capo	
	
	WriteUSART(13);				// invio carattere ritorno a capo

 }




