//*******************************************************************************************
//Misura dell'intensit luminosa
//*******************************************************************************************


void MeasureLight ()
{ 	static int data = 0;
	static unsigned char number = 0;		
		
	ADCON1 = 0b00001010;	//abilito ingressi analogici 
	ADCON2 = 0b10111110;	//imposto i tempi di conversione e giustificazione a destra
	ADCON0 = 0b00000001;	//abilito l'ADC AN0
		
	ADCON0bits.GO = 1; 		// Avvio la conversione Analogico/Digitale		
	while( ADCON0bits.GO); 	// Attendo la fine della conversione
	data = data + ReadADC(); // leggo il risultato della conversione	
	
	number++;
	
	if (number==8)
	
	{	data = data >> 3;	// con lo shift a destra divido per le letture  
							// fatte ottenendo il valore medio
		
		// ******************ISTERESI********************* 
			
		if (data> (NIGHT_LEVEL + LIGHT_FILTER) && Night ==1)
			{
				Night = 0;		
			}
		
		if (data < NIGHT_LEVEL)
			{
				Night = 1;		
			}
		// *****************FINE ISTERESI*****************			
	
		data =0;
		number = 0;
	}
}

//*******************************************************************************************
//Misura della temperatura
//*******************************************************************************************

void MeasureTemperature ()
{ 	static int data = 0;
	static unsigned char number = 0;		
		
	ADCON1 = 0b00001010;	//abilito ingressi analogici 
	ADCON2 = 0b10111110;	//imposto i tempi di conversione e giustificazione a destra
	ADCON0 = 0b00010001;	//abilito l'ADC AN4	
		
	ADCON0bits.GO = 1; 			// Avvio la conversione Analogico/Digitale		
	while( ADCON0bits.GO); 		// Attendo la fine della conversione
	data = data + ReadADC(); 	// leggo il risultato della conversione	
	
	number++;
	
	if (number==8)
	
	{	data = data >> 3;	// con lo shift a destra divido per le letture  
							// fatte ottenendo il valore medio
							
		temperature = data >>1; //ho 10mV/C e un quanto di 0,005mV quindi dividendo per due ho T
		data =0;
		number = 0;
	}
}


//*******************************************************************************************
//Misura del livello batteria
//*******************************************************************************************

void MeasureBattery ()
{ 	static int data = 0;
	static unsigned char number = 0;		
	
	ADCON1 = 0b00001010;	//abilito ingressi analogici
	ADCON2 = 0b10111110;	//imposto i tempi di conversione e giustificazione a destra
	ADCON0 = 0b00000101;	//abilito l'ADC AN1
		
	ADCON0bits.GO = 1; 			// Avvio la conversione Analogico/Digitale		
	while( ADCON0bits.GO); 		// Attendo la fine della conversione
	data = data + ReadADC(); 	// leggo il risultato della conversione	
	
	number++;
	
	if (number==8)
	
	{	data = data >> 3;	// con lo shift a destra divido per le letture  
							// fatte ottenendo il valore medio
		
		batteryLevel = data-796; //percentuale carica tra 11,7V e 13,2V
				
		data =0;
		number = 0;
	}
}
