 /*******************************************************
 ********************************************************
 
 Autore : Mauro Laurenti
 Versione : 1.1
 Data : 02/02/2007
 
 CopyRight 2007
 
 Domotino Firmware

 *******************************************************
 *******************************************************/
 
//includo le librerie 
 
#include <p18f4580.h>
#include <portb.h>
#include <ctype.h>
#include <usart.h>
#include <pwm.h>
#include <timers.h>
#include <delays.h>
#include <adc.h>
#include <i2c.h>

 
#include "\library\PCF8563.h" 
#include "\library\eeprom.h" 
#include "\Library\LCD_44780_Freedom.h"
#include "\Library\Sponsor.h" 

#include "\Robot\var.h"
#include "\Robot\Generic.h"	
#include "\Robot\motor.h"
#include "\Robot\servo.h"
#include "\Robot\sensors.h"
#include "\Robot\motion.h"
#include "\Robot\mod.h"
#include "\Robot\init.h"
#include "\Robot\commands.h"



#pragma config OSC = HS 		// 20Mhz
#pragma config WDT = OFF 		// disattivo il watchdog timer
#pragma config LVP = OFF 		// disattivo la programmazione LVP
#pragma config PBADEN = OFF 	// disabilito gli ingressi analogigi sulla PORTB


 void Low_Int_Event (void); 	// prototipo di funzione


 #pragma code low_vector=0x18

 void low_interrupt (void)
 {
 	_asm GOTO Low_Int_Event _endasm //imposta il salto per la gestione

 }

 #pragma code

 #pragma interruptlow Low_Int_Event

 void Low_Int_Event (void)
 { 	int i; // indice per il ciclo di pausa
	static unsigned char counter = 0;		//conatore byte ricevuti per il comando
	static unsigned char ResetUSART = 0;	// Flag per controllare il Time out in ricezione 
	static unsigned char num =0;			// variabile per il conteggio degli interrupt
		
	if (PIR1bits.RCIF == 1 )			// Controllo che l'interrupt sia stato generato dall'USART 
	{			
		data[counter] = ReadUSART(); 	// leggo il dato dal buffer di ricezione
		
 		counter++;	//incremento il numero di byte ricevuti
 		
 		if (counter > 7)	//quando ricevo 8 byte decodifico il comando ricevuto
 		{	
	 		if (data[0] != 'X')	//X  il comando per inviare il testo d' inizializzazione		
							
			WriteUSART(13);		// invio carattere ritorno a capo	
			
	 		for (i=0;i<8; i++)
				{
					WriteUSART(data[i]);  	// ritrasmetto il dato ricevuto
					while (BusyUSART());	// attendo che il dato venga trasmesso	
				}	 

	 		ComputeCommand (); 	//analizzo il comando ricevuto
	 		
	 		counter = 0;	 			 			 	
	 	} 	
	 	 	
	 	//Controllo che l'USART stia funzionando senza errori

		if (RCSTAbits.FERR==1 || RCSTAbits.OERR==1)
			{
					
				WriteUSART(13);				// invio carattere ritorno a capo
				while (BusyUSART());		// attendo che il dato venga trasmesso	
				putrsUSART("USART RX error");  	// Trasmetto il testo
				while (BusyUSART());		// attendo che il testo venga trasmesso
				
				CloseUSART ();	// effettuo una nuova inizializzazione dell'USART
				
				OpenUSART( USART_TX_INT_OFF &  // effettuo una nuova inizializzazione dell'USART
				USART_RX_INT_ON &
				USART_ASYNCH_MODE &
				USART_EIGHT_BIT &
				USART_CONT_RX &
				USART_BRGH_HIGH,
				64 ); 				
			}	
	 		 		
  		PIR1bits.RCIF = 0;		
	}
	


 	if (INTCONbits.RBIF == 1 ) // Controllo che l'interrupt sia stato generato da PORTB
 
	{	Delay (1);

 		if (RED_BUTTON==0)	// Controllo la pressione di RB7
 		{
 			if (ReadEEprom (0xA0,0x00,0x51) ==1)	//Controllo se fare il beep
				beep ();
 			
 			modality++;
 			
 			if (modality>NUM_MOD)
 				modality=1;		
		}
		
		if (LEFT_BUTTON==0)	// Controllo la pressione di RB7
 		{	
	 		Halt ();
	 		if (ReadEEprom (0xA0,0x00,0x52) ==1)	//Controllo se fare il beep
				beep ();
	 		 
	 		LeftCrash = 1;			
 		}
 		
 		if (RIGHT_BUTTON==0)	// Controllo la pressione di RB7
 		{	
	 		Halt ();
 			if (ReadEEprom (0xA0,0x00,0x52) ==1)	//Controllo se fare il beep
				beep ();
						 
 			RightCrash = 1;			
 		}		
		
		INTCONbits.RBIF = 0; //resetto il flag d'interrupt
 	}
 	
 	
 	
	if (INTCONbits.TMR0IF == 1 )	// Controllo che l'interrupt sia stato generato da TMR0 
	{		
 		num++;
 		
 		if (ServoDirection == 1)	//rinfresco la posizione del servo a 50Hz
 			ServoLeft ();
 		else
 			if (ServoDirection == 2)
 				ServoCenter ();
 			else
 				if (ServoDirection == 3)
 					ServoRight ();
 		
 		MeasureLight (); 		//effettuo una misura dell'intensit luminosa
 		MeasureBattery ();		// Leggo la tensione della batteria
 		MeasureTemperature ();	// Leggo la temperatura		

		
		 				
  		if (num == 20 || num == 40 || num == 60 || num == 80 || num == 100 || num == 120 || num == 140 || num == 160 || num == 180 || num == 200|| num == 220 || num == 240 || num == 255)
  		{	
	  		Trig = 1;		//invio dell'impulso di Trig
  			delay (50);
  			Trig = 0;  
  		}
  		
  		
  		if (num == 100)	// ogni 100 impulsi aggiorno ora e data di sistema e controllo flag allarme
  		{
  			Time = ReadTime();		//Leggo l'ora
  			Date = ReadDate ();		//leggo la data	
  			
  			if (IsAlarmON ())
  				timeAlarm = 1;		// attivo il flag per segnalare la sveglia
  				
  			if (counter > 0)		// se non ricevo altri byte enro 2 secondi riazzero il contatore byte
  				{
  					ResetUSART++;
  					if  (ResetUSART == 3)
  						{	
  							counter = 0;
  							ResetUSART = 0;
  							beep ();
  						}
  				}  			
  		}
  		  		
		INTCONbits.TMR0IF = 0;			
	}

 }


 void main (void)
 {
 	TRISA = 0xFF; 		// inizializzazione PORTA
 	PORTA = 0x00;

 	TRISB = 0b10110011; // inizializzazione PORTB
 	PORTB = 0x00 ;

 	TRISC = 0b10100000; // inizializzazione PORTC
 	PORTC = 0x00;

 	TRISD = 0b00000000; // inizializzazione PORTD
 	PORTD = 0x00;

 	TRISE = 0x00; 		// inizializzazione PORTE
 	PORTE = 0x00;
 	
  	
 	initialize ();  // inizializzo le periferiche di sistema

	//ciclo infinito in attesa d'interrupt
	//controllo la modalit da attivare
	
 	while (1)	
 	{
	 	if (modality == MODA)	//Modalit base
	 		modA ();
	 		
	 	if (modality == MODB)	//Explorer
	 		modB ();
	 	
	 	if (modality == MODC)	//Alarm (watch dog)
	 		modC ();
	 	
	 	if (modality == MODD)	//Orario Sveglia
	 		modD ();	 
	 	
	 	if (modality == MODE)	//Lamp Service
	 		modE ();
	 		
	 	if (modality == MODF)	//Lamp Service BIS
	 		modF ();	
	 		
	 	if (modality == MODG)	//Controllo Remoto
	 		modG ();	
	} 
 }
